
--
-- Copyright (C) 2022  <fastrgv@gmail.com>
--
-- This program is free software: you can redistribute it and/or modify
-- it under the terms of the GNU General Public License as published by
-- the Free Software Foundation, either version 3 of the License, or
-- (at your option) any later version.
--
-- This program is distributed in the hope that it will be useful,
-- but WITHOUT ANY WARRANTY; without even the implied warranty of
-- MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-- GNU General Public License for more details.
--
-- You may read the full text of the GNU General Public License
-- at <http://www.gnu.org/licenses/>.
--

with gl;  use gl;
with ada.finalization;
with unchecked_deallocation;


generic
	nperedge : integer; -- default about 3

package zfishobj is 
-- for textured rectangular exterior with 1 square per face in X/Y directions,
-- and multiple sections in Z direction.

type zfish is tagged private;

procedure setrect( rect: in out zfish;
xr,yr,zr : float );

procedure draw( rect: zfish; vertbuff, uvbuff, elembuff : gluint );

private

-- nperedge=7

nFaces : constant integer := 6;
nptsPerFace : constant integer := 4;
cpp : constant integer := 3; -- coords per point

nvert : constant integer := nFaces*nptsPerFace*cpp*nperedge; --504
nuv : constant integer := (nvert*2)/3; --336
nelm : constant integer := nvert/2; --252


type varray is array(1..nvert) of float;
type vap is access varray;

type tarray is array(1..nuv) of float;
type tap is access tarray;

type earray is array(1..nelm) of glushort;
type eap is access earray;

type zfish is new ada.finalization.controlled with record
	vert : vap;
	txuv : tap;
	elem : eap;
	nv,nu,ne : integer; --actual values
end record;


procedure initialize(rect: in out zfish);
procedure finalize(rect: in out zfish);

end zfishobj;

